%generates PSF from OPD coefficients
%snippet of MTFfit class
%https://www.strollswithmydog.com/simple-model-for-sharpness-in-digital-cameras-spherical-aberration/
                                        %um, simple model coefficients
o.c(1) = p.Results.def;                 %W020 or Z3
o.c(2) = p.Results.sa3;                 %W040 or Z8
o.c(3) = p.Results.sa5;                 %W060 or Z15

LAMBDAN = o.lambda * o.N;               %wavelength (um) and f-number
o.r = 0:LAMBDAN/16:128*LAMBDAN;         %um, psf x-axis (radius) range
[RHO,R] = meshgrid(0:1/100:1,o.r);      %pupil and psf radius range

if strcmpi(o.poly,'s')                  %Seidel polynomials
    fun = exp(1i*2*pi/o.lambda * ...
        ( o.c(1)*RHO.^2 + o.c(2)*RHO.^4 + o.c(3)*RHO.^6 ) )...
        .* besselj(0, pi*R/LAMBDAN .* RHO) .* RHO;
    
else                                    %Zernike polynomials
    fun = exp(1i*2*pi/o.lambda * (...
        o.c(1) * (2*RHO.^2) +...
        o.c(2) * (-6*RHO.^2 + 6*RHO.^4) +...
        o.c(3) * (12*RHO.^2 - 30*RHO.^4 + 20*RHO.^6) ) )...
        .* besselj(0, pi*R/LAMBDAN .* RHO) .* RHO;
end

o.psf = abs(trapz(fun,2)').^2;          %integrate, modulus^2
o.psf = o.psf/o.psf(1);                 %normalize to 1 at origin